defint a-z
'$include: 'tinyptc.bi'

declare sub pcopy ( byref dest() as integer, byref source() as integer)
const SCR_WIDTH = 320
const SCR_HEIGHT = 200
const SCR_SIZE = SCR_WIDTH*SCR_HEIGHT

const PI = 3.141593

type RGB
   r as ubyte
   g as ubyte
   b as ubyte
   a as ubyte
end type

   dim shared buffer( 0 to SCR_SIZE-1 ) as integer
   dim shared buffer2( 0 to SCR_SIZE-1 ) as integer
   dim shared Lsin1( -1024 to 1024) as integer
   dim shared Lsin2( -1024 to 1024) as integer 
   dim shared Lsin3( -1024 to 1024) as integer 
   dim shared Lcols(255) as RGB


    dim frame as long
    dim col as integer
    dim i as integer
    dim ofs as long
    dim rot as integer
    dim counter as integer, cdir as integer
    dim pixel as integer
    dim p as integer ptr
    dim p2 as integer ptr


   if( ptc_open( "freeBASIC v0.01 - plasma test (relsoft)", SCR_WIDTH, SCR_HEIGHT ) = 0 ) then
      end -1
   end if

    for i = -1024 to 1024
        Lsin1(i) = SIN(i / 64) * 56      'Play with these values
        Lsin2(i) = SIN(i / 164) * 128       'for different types of fx
        Lsin3(i) = SIN(i / 32) * 64        ';*)
    next i

    for i = 0 to 255
       Lcols(i).r = cint(abs(INT(128 - 127 * SIN(i * PI / 32))))
       Lcols(i).g = cint(abs(INT(128 - 127 * SIN(i * PI / 64))))
       Lcols(i).b = cint(abs(INT(128 - 127 * SIN(i * PI / 128))))
   next i
    p = @buffer2(0)
         FOR y = 0 TO SCR_HEIGHT-1
            FOR x = 0 TO SCR_WIDTH-1
                 *p =  (x xor y)
                 p = p + len( integer )
             NEXT x
         NEXT y


    counter = 0
    cdir = 1
    dim sp as integer
    dim dp as integer

    do
      counter = counter + cdir
         if( (counter < 1) or (counter > 4096) ) then
         cdir = -cdir
         end if


         p = @buffer(0)
         p2 = @buffer2(0)
         pcopy buffer(), buffer2()
         FOR y = 0 TO SCR_HEIGHT-1
             FOR x = 0 TO SCR_WIDTH-1
                 col = (Lsin3(x)  + Lsin1(x + Counter) + Lsin2(y )) and 255
                 sp = Lcols(col).r shl 16 or Lcols(col).g shl 8 or Lcols(col).b
                 dp = *p2
                 r = dp shr 16
                 g = (dp shr 8) and 255
                 b = dp and 255
                 r = (Lcols(col).r + r) shr 1
                 g = (Lcols(col).g + g) shr 1
                 b = (Lcols(col).b + b) shr 1
                 *p = r shl 16 or g shl 8 or b
                 p = p + len( integer )
                 p2 = p2 + len( integer )
             NEXT x
         NEXT y

      ptc_update varptr( buffer(0) )
   loop

   ptc_close


private sub pcopy ( byref dest() as integer, byref source() as integer)
    dim offset as long
    for offset = 0 to  SCR_SIZE -1
        buffer( offset ) = buffer2( offset )
    next offset

end sub

